package matrix;

public class Matrix {
    private int[][] a;
    private int n;
    public Matrix(int n)
    {
        this.n = n;
        a = new int[n][n];
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < n; j++)
                setElement(i,j,0);
            setElement(i,i,1);
        }
    }
    public Matrix(Matrix b)
    {
        this.n = b.n;
        this.a = new int[this.n][this.n];
        for (int i = 0; i < this.n; i++)
        {
            for (int j = 0; j < this.n; j++)
                setElement(i,j,b.getElement(i,j));
        }
    }
    public Matrix sum(Matrix b)
    {
        Matrix c = null;
        if (this.n != b.n)
        {
            return c;
        }
        c = new Matrix(this.n);
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < n; j++)
                c.setElement(i,j,getElement(i,j) + b.getElement(i, j));
        }
        return c;
    }
    public Matrix product(Matrix b)
    {
        Matrix c = null;
        if (this.n != b.n)
        {
            return c;
        }
        c = new Matrix(this.n);
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < n; j++)
                c.setElement(i,j,getElement(i,j) - b.getElement(i, j));
        }
        return c;
    }
    public boolean setElement(int row, int column, int value)
    {
        if (row < 0 || row >= n || column < 0 || column >= n) return false;
        else 
        {
            a[row][column] = value;
            return true;
        }
    }
    public int getElement(int row, int column)
    {
        return a[row][column];
    }
    @Override
    public String toString()
    {
        StringBuilder s = new StringBuilder("");
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < n; j++)
                s.append(getElement(i,j) + " ");
            if (i!=n-1) s.append("\n");
        }
        return s.toString();
    }
    public Matrix mult(Matrix b)
    {
        Matrix c = null;
        if (this.n != b.n)
        {
            return c;
        }
        c = new Matrix(this.n);
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < n; j++)
            {
                c.setElement(i,j,0);
                for (int k = 0; k < n; k++)
                {
                    c.setElement(i,j,c.getElement(i,j) + this.getElement(i,k) * b.getElement(k,j));
                }
            }
        }
        return c;
    }
    
    public static void main(String[] args) {
        Matrix m1 = new Matrix(2);
        System.out.println(m1);
        m1.setElement(0, 1, 1);
        m1.setElement(1, 0, 1);
        m1.setElement(1, 1, 0);
        System.out.println("");
        System.out.println("1- ");
        System.out.println(m1);
        Matrix m2 = new Matrix(m1);
        for (int i =2; i <= 10; i++)
        {
            m2 = m2.mult(m1);
            System.out.println(i + "- ");
            System.out.println(m2);
        }
    }
}

